#include <stdio.h>
#include <time.h>
#include <string.h>


/*Anzahl Enten*/
#define ENTEN 500
/*Anzahl, die sich paaren darf*/
#define PAAR 100
/*Groesse des Sees*/
#define SEEX 40
#define SEEY 16
/*Futterverteilung*/
#define FUTTER ((random()%5)<1)?1:0


#define CHRLEN (SEEX+SEEY-2)

int see[SEEX][SEEY];/*der see, 1=futter, 0=kein futter*/
int fit[ENTEN];/*fitness der enten*/
int maxfit=-1;/*maximale fitness im letzten durchlauf*/
int cntmfit=0;/*wie lange schon diese Fitness?*/
int startfit=0;/*beste Fitness am Start*/
char chromo[ENTEN][CHRLEN];/*entenchromosomen, 
        	char ist etwas kleiner: also virtuelle Pekingente*/

void test(int ente)
{
        int posx=0,posy=0,i;
        fit[ente]=0;
        /*Algorithmus*/
        for(i=0;i<CHRLEN;i++){
                /*sind wir rechts angestossen? Dann nur noch runter*/
                if(posx==(SEEX-1))chromo[ente][i]=1;
                /*sind wir unten angestossen? Dann nur noch nach rechts*/
                if(posy==(SEEY-1))chromo[ente][i]=0;
                /*normale genetische Interpretation*/
	        if(chromo[ente][i]){/*nach unten*/
                        posy++;
                } else {/*nach rechts*/
                        posx++;
                }
                if(see[posx][posy])fit[ente]++;
        }
}

void printente()
{
        int i,j,posx=0,posy=0;
        char c;
        for(i=0;i<CHRLEN;i++){
                /*sind wir rechts angestossen? Dann nur noch runter*/
                if(posx==(SEEX-1))chromo[0][i]=1;
                /*sind wir unten angestossen? Dann nur noch nach rechts*/
                if(posy==(SEEY-1))chromo[0][i]=0;
                /*normale genetische Interpretation*/
	        if(chromo[0][i]){/*nach unten*/
                        posy++;
                } else {/*nach rechts*/
                        posx++;
                }
                /*setze Position der Ente im See*/
                see[posx][posy]+=2;
        }
        /*Schreibe See auf Bildschirm*/
        for(i=0;i<SEEY;i++){
                for(j=0;j<SEEX;j++){
                        switch(see[j][i]){
                                case 0:c=' ';break;/*wasser*/
                                case 1:c='#';break;/*futter*/
                                case 2:c='+';break;/*ente was here*/
                                case 3:c='*';break;/*ente ist fetter*/
                                default: c='!';break;/*interner fehler*/
                        }
                        printf("%c",c);
                }
                printf("\n");
        }
}       

void tausche(int pos)
{
        int itmp;
        char ctmp[CHRLEN];
        /*tausche fitness*/
        itmp=fit[pos];
        fit[pos]=fit[pos+1];
        fit[pos+1]=itmp;
        /*tausche chromosomen*/
        memcpy(ctmp,chromo[pos],CHRLEN);
        memcpy(chromo[pos],chromo[pos+1],CHRLEN);
        memcpy(chromo[pos+1],ctmp,CHRLEN);
}

void dosort()
{
        int i,j;
        /*nicht optimiertes Bubblesort*/
        for(i=0;i<ENTEN;i++)
                for(j=0;j<(ENTEN-1);j++)
                        if(fit[j]<fit[j+1])tausche(j);
}

void fortpflanzen()
{
        /*Nur die besten 5 duerfen sich fortpflanzen und weiterleben.
        Da diese Enten kein Geschlecht haben wird per Zufall gepaart*/
        
        int i,c,v,m,w;
        
        for(c=PAAR;c<ENTEN;c++){/*alle Kinder durchgehen*/
                /*eltern waehlen*/
                m=v=random()%PAAR;
                while(m==v)m=random()%PAAR;
                /*bruchstelle fuer chromosom waehlen*/
                w=random()%CHRLEN;
                /*vererben*/
                for(i=0;i<CHRLEN;i++){
                        if(i<=w)/*solange kleiner w mutter, danach vater*/
                                chromo[c][i]=chromo[m][i];
                        else
                                chromo[c][i]=chromo[v][i];
                }
        }
}

int main()
{
        int i,j,cnt=0;
        
        /*Initialisierung*/
         /*Zufallsgenerator:*/
        srandom(time(NULL));
         /*Enten*/
        for(j=0;j<ENTEN;j++)
                for(i=0;i<CHRLEN;i++)
                        chromo[j][i]=random()&1;
         /*See*/
        for(j=0;j<SEEY;j++)
                for(i=0;i<SEEX;i++)
                        see[i][j]=FUTTER;
                        
        do{
                /*teste Fitness*/
                for(i=0;i<ENTEN;i++)test(i);
                /*Sortiere Enten*/
                dosort();
                /*checke fitness*/
                if(maxfit<fit[0]){
                        maxfit=fit[0];
                        cntmfit=0;
                }else cntmfit++;
                if(cnt==0)startfit=fit[0];
                /*next generation*/
                fortpflanzen();
                /**/
                cnt++;
        }while(cntmfit<5);
        
        printf("Durchlaeufe: %i\nFitness: %i -> %i\nGewinner-Ente:\n",cnt,startfit,maxfit);
        printente();
        
        /*neuer See*/
        for(j=0;j<SEEY;j++)
                for(i=0;i<SEEX;i++)
                        see[i][j]=FUTTER;
                        
        for(i=0;i<ENTEN;i++)test(0);
        printf("\nFitness im Fremdsee: %i\n",fit[0]);
        dosort();
        printf("Beste Fitness im Fremdsee: %i\n",fit[0]);
        printente();
        
}
